//==================================
// Взаимодействие генов
//==================================

#ifndef INTERACT_H
#define INTERACT_H

#define EPSINT 1.e-10
class interact{
public:
   interact(int &err, int colnum, int rows, int *x1,
   int *x2, double &pVal);
   ~interact();   // деструктор

private:
   int nDevN0(int dir, double& lnPt,  double& lnP0);
   bool isExist(int dx, int i, int j, int k);
   int ln_n(double &ln, int dx);
   double ln_Binom(int m, int n);
   int init(); // логарифм факториала
   int maxT(); // максимум T_ij

   //  переменные ---------
   int cols;   // кол-во столбцов
   int rows;   // кол-вол строк
   int* xMatr; // выб.1
   int* yMatr; // выб.2
   int* Tij;   // сумма гаплотипов
   int* Ri[2]; // сумма строки для 2-х выборок
   int* Cj[2]; // сумма столбца

   double* lnFact;// ln(x!)
   double ln_n0;  // логарифм n0 исходной таблицы
};

#endif // INTERACT_H
