//==================================
// точный тест Фишера
// вычисление 1-ой строки таблицы 2хс максимальной длины
// with fixed marginals Ri, Cj
//==================================

#ifndef LONGPATH_H
#define LONGPATH_H

#define MAX(X,Y) ((X)>(Y) ? (X) : (Y))
#define MIN(X,Y) ((X)<(Y) ? (X) : (Y))

#define MAXNUMCOL 100 // максимальное число столбцов

class longpath{
public:
   longpath(int &err, int maxSumTbl, double *fact);  // конструктор
   ~longpath();         // деструктор
   int getMode(int numColumn, int Row, int *Column, int *xMode);
//   unsigned long binCoeff(int m, int n);
   double ln_C(int m, int n);

private:
   int sumTbl; // сумма элементов таблицы
   int init;   // для getJ()
   int R1;     // сумма 1-ой строки
//   int *C;   // столбцы
   int *Clmn;   // столбцы
   int *Z;   // вектор z
   double *W;  // минимизируем
   double *lnFact;   // ln(x!)
   int numCol; // кол-во столбцов
   int N;      // сумма элементов таблицы
   int deltaZv;//  = delta*
   // функции ------------
   int getDeltaZ();
   int getJ();
//   int lnfact(int maxFact);
};

#endif // LONGPATH_H